org.deidentifier.arx.risk

## Class RiskEstimateBuilder

- java.lang.Object
- - org.deidentifier.arx.risk.RiskEstimateBuilder

    public class RiskEstimateBuilder
    extends java.lang.Object

A builder for risk estimates

Author:
  Fabian Prasser, Maximilian Zitzmann

### Constructor Summary

Constructors
Constructor and Description
`RiskEstimateBuilder(ARXPopulationModel population, DataHandleInternal handle, RiskModelHistogram classes, ARXConfiguration arxconfig)` Creates a new instance
`RiskEstimateBuilder(ARXPopulationModel population, DataHandleInternal handle, RiskModelHistogram classes, ARXSolverConfiguration solverconfig, ARXConfiguration arxconfig)` Creates a new instance
`RiskEstimateBuilder(ARXPopulationModel population, DataHandleInternal handle, java.util.Set<java.lang.String> identifiers, ARXConfiguration arxconfig)` Creates a new instance
`RiskEstimateBuilder(ARXPopulationModel population, DataHandleInternal handle, java.util.Set<java.lang.String> identifiers, ARXSolverConfiguration solverconfig, ARXConfiguration arxconfig)` Creates a new instance

### Method Summary

All Methods Instance Methods Concrete Methods
`RiskModelAttributes` `getAttributeRisks()` Returns a class providing access to an analysis of potential quasi-identifiers using the concepts of alpha distinction and alpha separation.
`RiskModelHistogram` `getEquivalenceClassModel()` Returns a model of the equivalence classes in this data set
`HIPAAIdentifierMatch[]` `getHIPAAIdentifiers()` Returns the a set of potential HIPAA identifiers.
`HIPAAIdentifierMatch[]` `getHIPAAIdentifiers(double threshold)` Returns the a set of potential HIPAA identifiers.
`RiskEstimateBuilderInterruptible` `getInterruptibleInstance()` Returns an interruptible instance of this object.
`RiskModelPopulationUniqueness` `getPopulationBasedUniquenessRisk()` Returns a class providing population-based uniqueness estimates
`RiskModelSampleRisks` `getSampleBasedReidentificationRisk()` Returns a class providing sample-based re-identification risk estimates
`RiskModelSampleRiskDistribution` `getSampleBasedRiskDistribution()` Returns a class representing the distribution of prosecutor risks in the sample
`RiskModelSampleSummary` `getSampleBasedRiskSummary(double threshold)` Returns a risk summary
`RiskModelSampleSummary` `getSampleBasedRiskSummary(double threshold, java.lang.String suppressed)` Returns a risk summary
`RiskModelSampleWildcard` `getSampleBasedRiskSummaryWildcard(double threshold)` Returns a risk summary, using wildcard matching. "*" will be interpreted as a wildcard
`RiskModelSampleWildcard` `getSampleBasedRiskSummaryWildcard(double threshold, java.lang.String wildcard)` Returns a risk summary, using wildcard matching
`RiskModelSampleUniqueness` `getSampleBasedUniquenessRisk()` Returns a class providing sample-based uniqueness estimates

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### RiskEstimateBuilder

    public RiskEstimateBuilder(ARXPopulationModel population,
                               DataHandleInternal handle,
                               RiskModelHistogram classes,
                               ARXConfiguration arxconfig)

Creates a new instance

Parameters:
  `population` -
  `handle` -
  `classes` -

#### RiskEstimateBuilder

    public RiskEstimateBuilder(ARXPopulationModel population,
                               DataHandleInternal handle,
                               RiskModelHistogram classes,
                               ARXSolverConfiguration solverconfig,
                               ARXConfiguration arxconfig)

Creates a new instance

Parameters:
  `population` -
  `handle` -
  `classes` -
  `solverconfig` -

#### RiskEstimateBuilder

    public RiskEstimateBuilder(ARXPopulationModel population,
                               DataHandleInternal handle,
                               java.util.Set<java.lang.String> identifiers,
                               ARXConfiguration arxconfig)

Creates a new instance

Parameters:
  `population` -
  `handle` -
  `identifiers` -

#### RiskEstimateBuilder

    public RiskEstimateBuilder(ARXPopulationModel population,
                               DataHandleInternal handle,
                               java.util.Set<java.lang.String> identifiers,
                               ARXSolverConfiguration solverconfig,
                               ARXConfiguration arxconfig)

Creates a new instance

Parameters:
  `population` -
  `handle` -
  `identifiers` -
  `solverconfig` -

### Method Detail

#### getAttributeRisks

    public RiskModelAttributes getAttributeRisks()

Returns a class providing access to an analysis of potential quasi-identifiers using the concepts of alpha distinction and alpha separation.

Returns:
  the RiskModelAttributes data from risk analysis

#### getEquivalenceClassModel

    public RiskModelHistogram getEquivalenceClassModel()

Returns a model of the equivalence classes in this data set

Returns:

#### getHIPAAIdentifiers

    public HIPAAIdentifierMatch[] getHIPAAIdentifiers()

Returns the a set of potential HIPAA identifiers. Values are matched with a confidence threshold of 50%

Returns:

#### getHIPAAIdentifiers

    public HIPAAIdentifierMatch[] getHIPAAIdentifiers(double threshold)

Returns the a set of potential HIPAA identifiers. Values are matched with the given confidence threshold.

Parameters:
  `threshold` - Confidence threshold
Returns:

#### getInterruptibleInstance

    public RiskEstimateBuilderInterruptible getInterruptibleInstance()

Returns an interruptible instance of this object.

Returns:

#### getPopulationBasedUniquenessRisk

    public RiskModelPopulationUniqueness getPopulationBasedUniquenessRisk()

Returns a class providing population-based uniqueness estimates

Returns:

#### getSampleBasedReidentificationRisk

    public RiskModelSampleRisks getSampleBasedReidentificationRisk()

Returns a class providing sample-based re-identification risk estimates

Returns:

#### getSampleBasedRiskDistribution

    public RiskModelSampleRiskDistribution getSampleBasedRiskDistribution()

Returns a class representing the distribution of prosecutor risks in the sample

Returns:

#### getSampleBasedRiskSummary

    public RiskModelSampleSummary getSampleBasedRiskSummary(double threshold)

Returns a risk summary

Parameters:
  `threshold` - Acceptable highest probability of re-identification for a single record. Please note that this threshold may be exceeded by up to 1% due to rounding issues.
Returns:

#### getSampleBasedRiskSummary

    public RiskModelSampleSummary getSampleBasedRiskSummary(double threshold,
                                                            java.lang.String suppressed)

Returns a risk summary

Parameters:
  `threshold` - Acceptable highest probability of re-identification for a single record. Please note that this threshold may be exceeded by up to 1% due to rounding issues.
  `suppressed` -
Returns:

#### getSampleBasedRiskSummaryWildcard

    public RiskModelSampleWildcard getSampleBasedRiskSummaryWildcard(double threshold)

Returns a risk summary, using wildcard matching. "*" will be interpreted as a wildcard

Parameters:
  `threshold` - Acceptable highest probability of re-identification for a single record. Please note that this threshold may be exceeded by up to 1% due to rounding issues.
Returns:

#### getSampleBasedRiskSummaryWildcard

    public RiskModelSampleWildcard getSampleBasedRiskSummaryWildcard(double threshold,
                                                                     java.lang.String wildcard)

Returns a risk summary, using wildcard matching

Parameters:
  `threshold` - Acceptable highest probability of re-identification for a single record. Please note that this threshold may be exceeded by up to 1% due to rounding issues.
  `wildcard` - String to interpret as a wildcard
Returns:

#### getSampleBasedUniquenessRisk

    public RiskModelSampleUniqueness getSampleBasedUniquenessRisk()

Returns a class providing sample-based uniqueness estimates

Returns: